svn commit: r213137 - head/etc/rc.d

Pawel Jakub Dawidek pjd at FreeBSD.org
Fri Sep 24 19:53:56 UTC 2010


Author: pjd
Date: Fri Sep 24 19:53:55 2010
New Revision: 213137
URL: http://svn.freebsd.org/changeset/base/213137

Log:
  Add gptboot script that is responsible for:
  - looking for partition with 'bootonce' attribute alone (without 'bootme'
    attribute), removing it and logging that we successfully booted from this
    partition.
  - looking for partitions with 'bootfailed' attribute, removing it and
    logging that we failed to boot from this partition.
  
  Reviewed by:	arch (Message-ID: <20100917234542.GE1902 at garage.freebsd.pl>)
  Obtained from:	Wheel Systems Sp. z o.o. http://www.wheelsystems.com
  MFC after:	2 weeks

Added:
  head/etc/rc.d/gptboot   (contents, props changed)
Modified:
  head/etc/rc.d/Makefile

Modified: head/etc/rc.d/Makefile
==============================================================================
--- head/etc/rc.d/Makefile	Fri Sep 24 19:49:12 2010	(r213136)
+++ head/etc/rc.d/Makefile	Fri Sep 24 19:53:55 2010	(r213137)
@@ -11,7 +11,7 @@ FILES=	DAEMON FILESYSTEMS LOGIN NETWORKI
 	dmesg dumpon \
 	encswap \
 	faith fsck ftp-proxy ftpd \
-	gbde geli geli2 gssd \
+	gbde geli geli2 gptboot gssd \
 	hastd hcsecd \
 	hostapd hostid hostid_save hostname \
 	inetd initrandom \

Added: head/etc/rc.d/gptboot
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/etc/rc.d/gptboot	Fri Sep 24 19:53:55 2010	(r213137)
@@ -0,0 +1,76 @@
+#!/bin/sh
+#
+# Copyright (c) 2010 Pawel Jakub Dawidek <pjd at FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# PROVIDE: gptboot
+# REQUIRE: mountcritremote
+# KEYWORD: nojail
+
+. /etc/rc.subr
+
+name="gptboot"
+start_cmd="gptboot_report"
+
+gptboot_report()
+{
+	gpart show | \
+		egrep '(^=>| freebsd-ufs .*(\[|,)(bootfailed|bootonce)(,|\]))' | \
+		sed 's/^=>//' | \
+		egrep -v '(\[|,)bootme(,|\])' | \
+	while read start size pos type attrs rest; do
+		case "${pos}" in
+		[0-9]*)
+			if [ -n "${disk}" ]; then
+				part="${disk}p${pos}"
+				echo "${attrs}" | egrep -q '(\[|,)bootfailed(,|\])'
+				bootfailed=$?
+				echo "${attrs}" | egrep -q '(\[|,)bootonce(,|\])'
+				bootonce=$?
+				if [ ${bootfailed} -eq 0 ]; then
+					logger -t gptboot -p local0.notice "Boot from ${part} failed."
+					gpart unset -a bootfailed -i ${pos} ${disk} >/dev/null
+				elif [ ${bootonce} -eq 0 ]; then
+					# We want to log success after all failures.
+					echo -n "Boot from ${part} succeeded."
+					gpart unset -a bootonce -i ${pos} ${disk} >/dev/null
+				fi
+			fi
+			;;
+		*)
+			if [ "${type}" = "GPT" ]; then
+				disk="${pos}"
+			else
+				disk=""
+			fi
+			;;
+		esac
+	done | logger -t gptboot -p local0.notice
+}
+
+load_rc_config $name
+run_rc_command "$1"


More information about the svn-src-all mailing list